#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/file.h>
#include <unistd.h>
#include <stdio.h>
#include <signal.h>
#include <errno.h>
#include <fcntl.h>

#include "config.h"
#include "global.h"
#include "itcp_vars.h"

/* global prototypes */
void sigHandler _ANSI_ARGS_((int signum));
int setasync _ANSI_ARGS_((int fd));
void recoverHandler _ANSI_ARGS_((int signum));


/* local prototypes */
void startRecoverTimer(void);
int getLockVal(void);
void putLockVal(int lockVal);
double getCurBitrate(void);
double getOrigBitrate(void);

/*======================================*/
void sigHandler (signum)
int signum;
{
struct msghdr *mymsg;
struct itcphdr idata;
int error;
int sockid;
pid_t pid;
pid_t child;
struct timespec *sleept;

   if ((signum == SIGIO) && EVENT){
        pid = getpid();
        sockid = getsid(pid, 7777);
        if (sockid){
                memset(&idata,0,sizeof(idata));
                error = recvmsg(sockid, mymsg, 7777, &idata);
                if (error){
                        perror("recvmsg");
                        exit(1);
                }
                switch(idata.event2app){
                	case 1: 
				if (mxlock == 0){
					mxlock = 1;
	                                sigIOcnt++;
        	                        itcpEvent = 1;
					rateOK = 0;
					startRecoverTimer();
				        if (!(child = fork())){
 		  		             execl("prog1","prog1", Reduct, Alpha, NULL);
					     exit(0);
					}
					usleep(100000);
				        mxlock = 0;
				}//end if(mxlock)
	                        break;

                	case 2: 
				if (mxlock == 0){
					mxlock = 1;
	                                sigIOcnt++;
        	                        itcpEvent = 1;
					rateOK = 0;
					startRecoverTimer();
				        if (!(child = fork())){
                	       	             execlp("prog2","prog2", Reduct, Alpha, NULL);
                        	       	     exit(0);
                               		}
					usleep(100000);
					mxlock = 1;
				} //end if(mxlock)
                          	break;
                }//end switch
          }//end if(sockid)
   }//end if(signum)
}//end sigHandler

/*===========================*/
int setasync(fd)
int fd;
{
        int flags;
        if (fcntl(fd, F_SETOWN, getpid()) != -1) {
                flags = fcntl(fd, F_GETFL, 0);
                if (flags != -1)
                        return(fcntl(fd, F_SETFL, (flags|FASYNC)));
        }
        return(-1);
}
/*==========================*/

void recoverHandler(int signum) {
FILE *testf;
double rbit_rate, ibit_rate, calc_rate, nbit_rate;
double Alpha;

   if (signum == SIGALRM){
	sigTIMEcnt++;
	waitTIMEcnt++;
        Alpha = ((double) ALPHA) * 0.01;

        if  ( (waitTIMEcnt) &&
	      ((waitTIMEcnt == 400) || ((waitTIMEcnt > 400) && ((waitTIMEcnt % 300) == 0))) &&
              (rateOK == 0) )
	{ 
              if (mxlock == 0){
		     mxlock = 1;

                     if (waitTIMEcnt > 400 )
                           Alpha *=1.2;
 
		     rbit_rate = getCurBitrate();
		     ibit_rate = getOrigBitrate();

   		     calc_rate = rbit_rate / Alpha;

                     if (calc_rate >= ibit_rate){
		        nbit_rate = ibit_rate;
			rateOK = 1;
		     }
		     else
			nbit_rate = calc_rate;

	             if (!(testf = fopen("test.log", "a"))) {
		           perror("test file [test.log]");
		           exit(1);
		     }
		     fprintf(testf,"recoverHandler: recovering from iTCP rate reduction.\n");
		     fprintf(testf,"recoverHandler: current bit_rate = %lf\n", rbit_rate);
		     fprintf(testf,"recoverHandler: waitTIMEcnt = %d\n", waitTIMEcnt);

		     if (!(rrate = fopen("rate.par", "w"))) {
		     	   perror("parameter file [rate.par]");
		     	   exit(1);
		     }
		     if ( REDUCT ){
		        fprintf(rrate,"%lf",nbit_rate);
 	                fprintf(testf,"recoverHandler: %lf --> \"rate.par\", ALPHA = %lf.\n\n",nbit_rate, Alpha);
		     } else {
		        fprintf(rrate,"%lf",rbit_rate);
 	                fprintf(testf,"recoverHandler: %lf --> \"rate.par\", ALPHA = %lf.\n\n",rbit_rate, Alpha);
		     }//end if(REDUCT)   
		     fclose(rrate);
		     fclose(testf);
		     mxlock = 0;
              }//end if(mxlock)
	}//end if(waitTime++)
   }//if (signum==)

}//end recoverHandler
/*==========================*/

void startRecoverTimer(void){
   waitVal.it_value.tv_sec = 0;
   waitVal.it_value.tv_usec = 1;
   waitVal.it_interval.tv_sec = 0;
   waitVal.it_interval.tv_usec = 10000;
   waitTIMEcnt = 0;
   if (setitimer(ITIMER_REAL, &waitVal, NULL) < 0){
        perror("setitimer");
        exit(1);
   }
}
/*=================================*/

double getCurBitrate(void){
double rbit_rate;
   if (!(rrate = fopen("rate.par", "r"))) {
        perror("parameter file [rate.par]");
        exit(1);
   }
   fscanf(rrate,"%lf",&rbit_rate);
   fclose(rrate);
   return rbit_rate;
}
/*=================================*/

double getOrigBitrate(void){
double ibit_rate;
   if (!(irate = fopen("irate.par", "r"))) {
        perror("parameter file [irate.par]");
        exit(1);
   }
   fscanf(irate,"%lf",&ibit_rate);
   fclose(irate);
   return ibit_rate;	
}
/*=================================*/
